using UnityEngine;
using UnityEditor;

namespace Passer.Humanoid {

    public class OnLoadHumanoidPlayerNetcode {

        public static void CheckHumanoidPlayer() {
            string prefabPath = OnLoadHumanoidPlayer.GetHumanoidPlayerPrefabPath();
            GameObject playerPrefab = OnLoadHumanoidPlayer.GetHumanoidPlayerPrefab(prefabPath);

#if hNETCODE
            Unity.Netcode.NetworkManager nwManager = Object.FindObjectOfType<Unity.Netcode.NetworkManager>();
            if (nwManager == null) {
                NetworkingStarter nwStarter = Object.FindObjectOfType<NetworkingStarter>();
                if (nwStarter != null)
                    nwManager = nwStarter.gameObject.AddComponent<Unity.Netcode.NetworkManager>();
            }

            Unity.Netcode.NetworkConfig nwConfig = nwManager.NetworkConfig;
            if (nwConfig.NetworkTransport == null) {
                Unity.Netcode.Transports.UTP.UnityTransport unityTransport = new();
                nwConfig.NetworkTransport = unityTransport;
            }
            if (nwConfig.PlayerPrefab == null)
                nwConfig.PlayerPrefab = (GameObject)Resources.Load("HumanoidPlayer");

            if (playerPrefab != null) {
                Unity.Netcode.NetworkObject nwId = playerPrefab.GetComponent<Unity.Netcode.NetworkObject>();
                if (nwId == null)
                    nwId = playerPrefab.AddComponent<Unity.Netcode.NetworkObject>();
            }
#else
            if (nwManager != null)
                Object.DestroyImmediate(nwManager, true);

            if (playerPrefab != null) {
                NetworkIdentity nwId = playerPrefab.GetComponent<NetworkIdentity>();
                if (nwId != null)
                    Object.DestroyImmediate(nwId, true);
            }
#endif
            OnLoadHumanoidPlayer.UpdateHumanoidPrefab(playerPrefab, prefabPath);
        }
    }
}
